package cz.neit.dm.controllers;

import cz.neit.dm.services.CategoryService;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping("categories")
public class CategoryController {

    private final CategoryService categoryService;

    public CategoryController(CategoryService categoryService) {
        this.categoryService = categoryService;
    }

    @PreAuthorize("hasPermission('category', 'viewAll')")
    @GetMapping("")
    public List<String> getListOfCategories(){
        return categoryService.getAllCategories();
    }
}
