package cz.neit.dm.controllers;

import cz.neit.dm.dtos.modeldto.DownloadHistoryDTO;
import cz.neit.dm.services.DownloadHistoryService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * Created by jhruby on 26.09.2018
 */
@Slf4j
@RestController
@RequestMapping("download-history")
public class DownloadHistoryController {

    private final DownloadHistoryService downloadHistoryService;

    public DownloadHistoryController(DownloadHistoryService downloadHistoryService) {
        this.downloadHistoryService = downloadHistoryService;
    }

    @PreAuthorize("hasPermission('history', 'showHistory')")
    @GetMapping("")
    public List<DownloadHistoryDTO> getDownloadHistory(){
        return downloadHistoryService.getDownloadHistoryForCurrentUser();
    }
}
