package cz.neit.dm.controllers;

import cz.neit.dm.dtos.modeldto.RecipientDTO;
import cz.neit.dm.services.RecipientService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * Created by jhruby on 25.09.2018
 */

@Slf4j
@RestController
@RequestMapping("recipients")
public class RecipientController {

    private final RecipientService recipientService;

    public RecipientController(RecipientService recipientService) {
        this.recipientService = recipientService;
    }

    @PreAuthorize("hasPermission('recipient', 'viewAll')")
    @GetMapping("")
    public List<RecipientDTO> getRecipients(@RequestParam(value = "email", required = false) String emailQuery) {
        if (emailQuery == null || emailQuery.isEmpty()) {
            return recipientService.getAllRecipientsDTO();
        } else {
            return recipientService.getRecipientsByEmail(emailQuery);
        }
    }

}