package cz.neit.dm.dtos.modeldto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.Positive;
import javax.validation.constraints.PositiveOrZero;
import java.time.LocalDate;

/**
 * Created by jhruby on 15.04.2019
 */
@Data
@ApiModel(description = "Default user settings, for preset values in process of uploading file nd creating link")
public class DefaultUserSettingsDTO {
    @Positive
    @ApiModelProperty(value = "Unique identificator")
    private Long id;

    @ApiModelProperty(value = "Category for better filtering")
    private String category;

    @ApiModelProperty(value = "Simple information about group, under which will be file uploaded")
    private GroupSimpleDTO group;

    @ApiModelProperty(value = "Info about author privacy of the file")
    private boolean onlyAuthorCanDownload;

    @ApiModelProperty(value = "Information about date, when the file will be deleted from server")
    private DeleteDateDTO deleteDate;

    @ApiModelProperty(value = "Subject of mail")
    private String mailSubject;

    @ApiModelProperty(value = "Text for mail")
    private String mailText;

    @ApiModelProperty(value = "Expiration date of link")
    private LocalDate validUntil;

    @ApiModelProperty(value = "Download limit from link")
    @PositiveOrZero(message = "Počet stažení nesmí být záporný.")
    private Long downloadsLimit;
}
