package cz.neit.dm.dtos.modeldto;

import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.datatype.jsr310.deser.LocalDateDeserializer;
import com.fasterxml.jackson.datatype.jsr310.ser.LocalDateSerializer;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.FutureOrPresent;
import javax.validation.constraints.Max;
import javax.validation.constraints.Positive;
import java.time.LocalDate;

/**
 * Created by jhruby on 26.02.2019
 */

@Data
@NoArgsConstructor
@ApiModel(description = "Contains possible values of deleting file from server")
public class DeleteDateDTO {

    @ApiModelProperty(value = "Unique identificator")
    private Long id;

    @ApiModelProperty(value = "State about never deleting file from filesystem")
    private Boolean neverDelete;

    @ApiModelProperty(value = "State about deletion file after the number of downloads from link is exceeded")
    private Boolean deleteAfterLimitExceeded;

    @ApiModelProperty(value = "Number of days which will be add to the latest date of file sharing ")
    @Positive
    @Max(value = 3650, message = "Počet dní nesmí přesáhnout 3650.")
    private Integer daysAfterLastShare;

    @ApiModelProperty(value = "Date when file will be deleted form filesystem")
    @JsonDeserialize(using = LocalDateDeserializer.class)
    @JsonSerialize(using = LocalDateSerializer.class)
    @FutureOrPresent(message = "Datum smazání souboru musí být budoucí")
    private LocalDate willBeDeletedAt;
}
