package cz.neit.dm.dtos.modeldto;

import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.datatype.jsr310.deser.LocalDateDeserializer;
import com.fasterxml.jackson.datatype.jsr310.ser.LocalDateSerializer;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.time.LocalDate;

/**
 * Created by jhruby on 26.02.2019
 */

@Data
@NoArgsConstructor
@ApiModel(description = "Contains simple info if file will be never deleted or date when")
public class DeleteDateSimpleDTO {

    @ApiModelProperty(value = "State about never deleting file from filesystem")
    private Boolean neverDelete;

    @ApiModelProperty(value = "State about deletion file after the number of downloads from link is exceeded")
    private Boolean deleteAfterLimitExceeded;

    @ApiModelProperty(value = "Final date when file will be deleted form filesystem")
    @JsonDeserialize(using = LocalDateDeserializer.class)
    @JsonSerialize(using = LocalDateSerializer.class)
    private LocalDate dayOfDelete;

}
