package cz.neit.dm.dtos.modeldto;

import cz.neit.dm.entity.FileDM;
import cz.neit.dm.entity.Link;
import cz.neit.dm.entity.User;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.PastOrPresent;
import java.time.LocalDateTime;

/**
 * Created by jhruby on 26.09.2018
 */
@Data
@NoArgsConstructor
@ApiModel(description = "Information about download history, contains every record of download, of who download, what and when")
public class DownloadHistoryDTO {

    @ApiModelProperty(value = "Unique identificator")
    private Long id;

    @PastOrPresent
    @ApiModelProperty(value = "Date with time when the file was downloaded")
    private LocalDateTime downloadedAt;

    @ApiModelProperty(value = "Email of recipient who download file from link")
    private String recipient;

    @ApiModelProperty(value = "Logged user who download file from app")
    private User user;

    @ApiModelProperty(value = "Link which provide download of file")
    private Link link;

    @ApiModelProperty(value = "Downloaded file")
    private FileDM file;

    @ApiModelProperty(value = "Simple value of file name")
    private String fileName;
}
