package cz.neit.dm.dtos.modeldto;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import java.util.List;

/**
 * Created by jhruby on 22.08.2018
 */
@Data
@NoArgsConstructor
@JsonIgnoreProperties(ignoreUnknown = true)
@ApiModel(description = "Complex information about with collection of members and files")
public class GroupDTO {

    @ApiModelProperty(value = "Unique identificator")
    private Long id;

    @ApiModelProperty(value = "Name of group")
    @NotBlank(message ="Jméno skupiny nesmí být prázdné.")
    @Size(min = 2, max = 32, message = "Jméno skupiny musí být v rozmezí 2-32 znaků.")
    private String name;

    @ApiModelProperty(value = "Description of group, purpose of group")
    @Size(max = 1000, message = "Popis skupiny nesmí být delší jak 1000 znaků.")
    private String description;

    @ApiModelProperty(value = "Users and their roles in the current group")
    private GroupUsersDTO members;

    @ApiModelProperty(value = "Collection of simple information about files uploaded under the group")
    private List<FileSimpleDTO> files;
}
