package cz.neit.dm.dtos.modeldto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;

/**
 * Created by jhruby on 21.08.2018
 */

@Data
@NoArgsConstructor
@ApiModel(description = "Simple information about groups and their names and descriptions, without collection of members or files. For preview")
public class GroupSimpleDTO {

    @ApiModelProperty(value = "Unique identificator")
    private Long id;

    @ApiModelProperty(value = "Name of group")
    @NotBlank(message ="Jméno skupiny nesmí být prázdné.")
    @Size(min = 2, max = 32, message = "Jméno skupiny musí být v rozmezí 2-32 znaků.")
    private String name;

    @ApiModelProperty(value = "Description of group, purpose of group")
    @Size(max = 1000, message = "Popis skupiny nesmí být delší jak 1000 znaků.")
    private String description;
}
