package cz.neit.dm.dtos.modeldto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.Email;

/**
 * Created by jhruby on 19.09.2018
 */
@Data
@NoArgsConstructor
@ApiModel(description = "Recipients with email, to which links are sent")
public class RecipientDTO {

    @ApiModelProperty(value = "Unique identificator")
    private Long id;

    @ApiModelProperty(value = "Name of recipient, optional. Prepared for collection of recipients")
    private String name;

    @ApiModelProperty(value = "Email for recipient, on which will be sent email")
    @Email
    private String email;

}
