package cz.neit.dm.dtos.modeldto;

import cz.neit.dm.entity.enums.Language;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.Email;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.Size;

/**
 * Created by jhruby on 20.08.2018
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@ApiModel(description = "Information about user without password")
public class UserSimpleDTO {

    @ApiModelProperty(value = "Unique identificator")
    protected Long id;

    @ApiModelProperty(value = "Unique identification, used for login")
    @NotEmpty(message = "Uživatelské jméno nesmí být prázdné.")
    @Size(max = 255)
    protected String username;

    @ApiModelProperty(value = "First name of user")
    @NotEmpty(message = "Jméno uživatele nesmí být prázdné.")
    @Size(max = 100, message = "Jméno uživatele nesmí být delší jak 100 znaků.")
    protected String firstname;

    @ApiModelProperty(value = "Surname of user")
    @NotEmpty(message = "Přijmení uživatele nesmí být prázdné.")
    @Size(max = 100, message = "Příjmení uživatele nesmí být delší jak 100 znaků.")
    protected String lastname;

    @ApiModelProperty(value = "First and last name")
    @Size(max = 255, message = "Celé jméno nesmí být prázdné.")
    protected String fullname;

    @ApiModelProperty(value = "Email of user, need for reset password of the user")
    @NotEmpty(message = "Email uživatele nesmí být prázdný.")
    @Email(message = "Email musí být ve správném tvaru.")
    @Size(max = 255, message = "Délka emailu nesmí být delší jak 255 znaků")
    protected String email;

    @ApiModelProperty(value = "Role in application, can be user or administrator")
    @Size(max = 255)
    protected String role;

    @ApiModelProperty(value = "Option of language")
    protected Language language;
}
