package cz.neit.dm.dtos.modeldto;

import cz.neit.security.permission.hints.simple.PermissionsWrapper;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

/**
 * Created by jhruby on 03.01.2019
 */
@Data
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
@ApiModel(description = "User with permissions assigned over the groups and roles")
public class UserWithPermissionsDTO extends UserSimpleDTO {


    @ApiModelProperty(value = "Current permission allocated to user")
    private PermissionsWrapper permissions;

    public UserWithPermissionsDTO(UserSimpleDTO userSimpleDTO, PermissionsWrapper permissions) {
        super(userSimpleDTO.getId(), userSimpleDTO.getUsername(), userSimpleDTO.getFirstname(), userSimpleDTO.getLastname(),
                userSimpleDTO.getFullname(), userSimpleDTO.getEmail(), userSimpleDTO.getRole(), userSimpleDTO.getLanguage());

        this.permissions = permissions;
    }
}
