package cz.neit.dm.entity;

import lombok.*;

import javax.persistence.*;
import java.time.LocalDate;

/**
 * Created by jhruby on 16.04.2019
 */
@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Entity
public class DefaultUserSettings {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @ManyToOne
    @JoinColumn(name="category_id")
    private Category category;

    @ManyToOne
    @JoinColumn(name="group_id")
    private Group group;

    private boolean onlyAuthorCanDownload;

    @OneToOne(orphanRemoval = true, cascade = CascadeType.ALL)
    private DeleteDate deleteDate;

    private String mailSubject;
    private String mailText;
    private LocalDate validUntil;
    private Long downloadsLimit;
}
