package cz.neit.dm.entity;

import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.datatype.jsr310.deser.LocalDateDeserializer;
import com.fasterxml.jackson.datatype.jsr310.ser.LocalDateSerializer;
import lombok.*;

import javax.persistence.*;
import javax.validation.constraints.FutureOrPresent;
import javax.validation.constraints.Max;
import javax.validation.constraints.Positive;
import java.time.LocalDate;

@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Entity
@Table(name="dm_delete_day")
public class DeleteDate {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    private Boolean neverDelete;
    private Boolean deleteAfterLimitExceeded;

    @Positive
    @Max(value = 3650, message = "Počet dní nesmí přesáhnout 3650.")
    private Integer daysAfterLastShare;

    @JsonDeserialize(using = LocalDateDeserializer.class)
    @JsonSerialize(using = LocalDateSerializer.class)
    @FutureOrPresent(message = "Datum smazání souboru musí být dněšní nebo budoucí")
    private LocalDate willBeDeletedAt;
}

