package cz.neit.dm.entity;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.hibernate.annotations.Type;

import javax.persistence.*;
import java.time.LocalDate;
import java.util.ArrayList;
import java.util.List;

@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Entity
@Table(name="dm_file")
public class FileDM {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    private String filename;
    private Long filesize;
    private String format;
    private LocalDate uploadedAt;
    private LocalDate sharedUpTo;
    private LocalDate lastDownloadViaLink;

    @Type(type = "text")
    private String description;
    private boolean onlyAuthorCanDownload;

    @ManyToOne
    @JoinColumn(name = "category_id")
    private Category category;

    @OneToOne(orphanRemoval = true, cascade = CascadeType.ALL)
    private DeleteDate deleteDate;

    @ManyToOne
    @JoinColumn(name = "group_id")
    private Group group;

    @ManyToOne
    @JoinColumn(name = "user_id")
    private User author;

    @OneToMany(orphanRemoval = true, cascade = CascadeType.ALL, mappedBy = "file")
    private List<Link> links = new ArrayList<>();

    @OneToMany(mappedBy = "file", cascade = CascadeType.PERSIST)
    private List<DownloadHistory> downloadHistory = new ArrayList<>();

}
