package cz.neit.dm.entity;

import com.fasterxml.jackson.annotation.JsonIgnore;
import cz.neit.dm.entity.enums.MembershipType;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;

@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Entity
@Table(name="dm_group_membership")
public class GroupMembership {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @JsonIgnore
    @ManyToOne
    @JoinColumn(name = "user_id")
    private User user;

    @JsonIgnore
    @ManyToOne
    @JoinColumn(name = "group_id")
    private Group group;

    @Enumerated(value = EnumType.STRING)
    private MembershipType membershipType;

    public GroupMembership(User user, Group group, MembershipType membershipType) {
        this.user = user;
        this.group = group;
        this.membershipType = membershipType;
    }
}
