package cz.neit.dm.entity;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.*;
import org.hibernate.annotations.Type;

import javax.persistence.*;
import java.time.LocalDate;
import java.util.ArrayList;
import java.util.List;

@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Entity
@Table(name="dm_link")
public class Link {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    private String mainToken;

    private LocalDate createdAt;
    private LocalDate lastShare;
    private LocalDate validUntil;
    private Long downloadsLimit;
    private Long downloadsCount;
    private String mailSubject;

    @Column(name = "mail_text", columnDefinition = "TEXT")
    private String mailText;
    private boolean shared;

    @Type(type = "text")
    private String description;

    @ManyToOne
    @JsonIgnore
    private FileDM file;

    @ManyToOne
    @JoinColumn(name = "author_id")
    private User author;

    @OneToMany(orphanRemoval = true, cascade = CascadeType.ALL, mappedBy = "link")
    @JsonIgnore
    private List<SideLink> sideLinks = new ArrayList<>();
}
