package cz.neit.dm.entity;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import javax.persistence.*;
import java.util.ArrayList;
import java.util.List;

@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Entity
@Table(name = "dm_side_link", uniqueConstraints = {@UniqueConstraint(name = "uniqueSideLinkConstraint", columnNames = {"link_id", "recipient_id"})})
public class SideLink {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @JsonProperty("id")
    private Long id;

    private String token;

    @ManyToOne
    private Link link;

    @ManyToOne
    private Recipient recipient;

    @OneToMany(mappedBy = "sideLink", cascade = CascadeType.PERSIST)
    private List<DownloadHistory> downloadHistory = new ArrayList<>();
}
