package cz.neit.dm.helpers;

import cz.neit.dm.exceptions.BadRequestException;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import javax.validation.ConstraintViolation;
import javax.validation.Validator;
import java.util.Set;

@Component
@Slf4j
public class BaseEntityValidator<T> implements EntityValidator<T> {

    protected final Validator validator;

    public BaseEntityValidator(Validator validator) {
        this.validator = validator;
    }

    public Set<ConstraintViolation<T>> validate(T t) {
        return validator.validate(t);
    }

    @Override
    public void sendErrorMessageAndThrowBadRequest(String message) {
        log.error(message);
        throw new BadRequestException(message);
    }



}
