package cz.neit.dm.repositories;

import cz.neit.dm.entity.User;
import cz.neit.security.acl.IResourceRepository;
import org.springframework.data.repository.CrudRepository;

import java.util.List;
import java.util.Optional;

public interface UserRepository extends CrudRepository<User, Long>, IResourceRepository<User, Long> {

    /**
     * Load information about user using username.
     * @param username of the user
     * @return User if exists.
     */
    Optional<User> findByUsername(String username);
    Optional<User> findByEmail(String email);

    List<User> findAllByFullnameLikeIgnoreCase(String fullname);

}
