package cz.neit.dm.security;

import org.springframework.http.HttpStatus;
import org.springframework.security.core.AuthenticationException;
import org.springframework.security.web.AuthenticationEntryPoint;
import org.springframework.stereotype.Component;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

/**
 * Created by jhruby on 28.11.2018
 */

@Component
public class RestAuthenticationEntryPoint implements AuthenticationEntryPoint {

    /**
     * Invoked when user tries to access endpoint which is under authentication and user was not authenticated.
     * Error message with 401 http status code is sent back.
     */
    @Override
    public void commence(HttpServletRequest request, HttpServletResponse response,
                         AuthenticationException authException) throws IOException {
        System.out.println("Logged out, token was expired");
        response.sendError(HttpStatus.UNAUTHORIZED.value(), authException.getMessage());
    }
}
