package cz.neit.dm.security.acl.conditions;

import cz.neit.dm.entity.Group;
import cz.neit.dm.entity.GroupMembership;
import cz.neit.dm.entity.User;
import cz.neit.dm.entity.enums.MembershipType;
import org.springframework.security.core.userdetails.UserDetails;

/**
 * Created by jhruby on 01.12.2018
 */
public class GroupConditions {

    public static boolean isMember(UserDetails userDetails, Group group) {
        if (!(userDetails instanceof User) ||
                group == null) {
            return false;
        }
        return ((User) userDetails).getGroupMemberships()
                .stream()
                .map(GroupMembership::getGroup)
                .anyMatch(g -> g.getId().equals(group.getId()));
    }

    public static boolean isManager(UserDetails userDetails, Group group) {
        if (!(userDetails instanceof User) ||
                group == null) {
            return false;
        }
        GroupMembership groupMembership = ((User) userDetails).getGroupMemberships()
                .stream()
                .filter(g -> g.getGroup().getId().equals(group.getId()))
                .findFirst()
                .orElse(null);

        if (groupMembership == null) {
            return false;
        }

        return MembershipType.MANAGER.equals(groupMembership.getMembershipType());
    }
}
