package cz.neit.dm.services;

import cz.neit.dm.dtos.modeldto.UserSimpleDTO;
import cz.neit.dm.entity.GroupMembership;
import cz.neit.dm.entity.User;

import java.util.List;

/**
 * Created by jhruby on 25.07.2018
 */
public interface GroupMembershipService {

    // *********** GETTERS
    List<GroupMembership> getMembershipByUserId(Long userId);
    List<GroupMembership> getManagersForGroup(Long groupId);


    GroupMembership getMembershipByGroupIdAndUserId(Long groupId, Long userId);
    List<Long> getGroupIdsForCurrentUser();

    // *********** DELETE
    void deleteManagerGroupMembership(Long groupId, Long userId);

    void deleteGroupMembership(Long groupId, Long userId, User newAuthor);

    boolean hasUserFilesInGroup(Long groupId, Long userId);

    List<UserSimpleDTO> getManagersOfGroupForNewAuthor(Long groupId, Long userId);

    List<UserSimpleDTO> getAllManagers();

    // *********** ASSIGN USERS and MANAGERS to GROUP
    GroupMembership assignUserToGroup(Long groupId, Long userId);
    GroupMembership assignManagerToGroup(Long groupId, Long userId);

}
