package cz.neit.dm.services;

import cz.neit.dm.dtos.modeldto.GroupDTO;
import cz.neit.dm.dtos.modeldto.GroupSimpleDTO;
import cz.neit.dm.entity.Group;

import java.util.List;

/**
 * Created by jhruby on 25.07.2018
 */

public interface GroupService {

    // *********** GETTERS
    GroupDTO getGroupDetailsDTO(Long id);
    Group getGroupDetails(Long id);
    GroupDTO getGroupDetailsByNameDTO(String name);

    // *********** GETTERS LIST
    List<Group> getAllGroups();
    List<GroupDTO> getAllGroupsDTO();
    List<GroupDTO> getAllUnassignedGroups(Long userId);
    List<GroupDTO> getAllGroupsByCurrentUser();

    // *********** CRUD
    GroupSimpleDTO createGroup(GroupSimpleDTO groupSimpleDTO);
    GroupSimpleDTO updateGroup(Long id, GroupSimpleDTO groupSimpleDTO);
    void deleteGroup(Long id);

    // *********** CONDITIONS FOR ENDPOINTS
    boolean isDeletable(Long groupId);


}
