package cz.neit.dm.services;

import cz.neit.dm.dtos.modeldto.LinkDTO;
import cz.neit.dm.dtos.modeldto.LinkValidationDTO;
import cz.neit.dm.entity.Link;
import cz.neit.dm.entity.Recipient;

import java.util.List;

/**
 * Created by jhruby on 05.09.2018
 */
public interface LinkService {

    // *********** GETTERS LIST
    List<Link> getAllLinks();
    List<LinkDTO> getAllLinksDTO();
    List<LinkDTO> getLinksForCurrentUser();
    List<LinkDTO> getLinksDTOWithoutGroup();
    List<Recipient> getRecipientsByLinkId(Long linkId);

    // *********** GETTERS
    Link getLinkDetails(Long linkId);
    LinkDTO getLinkDetailDtoWithRecipients(Long linkId);

    // *********** SHARE OR DISABLE LINK FOR CUSTOMERS
    LinkDTO shareLink(Long linkId);
    LinkDTO disableLink(Long linkId);

    // *********** CRUD
    LinkDTO createLink(LinkDTO linkDTO);
    LinkDTO updateLink(Long linkId, LinkDTO linkDTO);
    void deleteLink(Long linkId);

    // *********** CONDITIONS FOR ENDPOINTS
    boolean isDownloadsCountLimitExceeded(Link link);
    boolean isValidUntilDateExceeded(Link link);

    LinkValidationDTO isAnyLinkFileIncorrect(Link link);

    // *********** SCHEDULING
    void disableDeprecatedLinks();

    void setPlusActualDownloadsCount(Link link);
}
