package cz.neit.dm.services;

import cz.neit.dm.dtos.modeldto.UserDTO;
import cz.neit.dm.dtos.modeldto.UserSimpleDTO;
import cz.neit.dm.entity.PasswordResetToken;
import cz.neit.dm.entity.User;

import java.util.List;

/**
 * Created by jhruby on 25.07.2018
 */
public interface UserService {

    // *********** GETTERS LIST
    List<UserDTO> getAllUsers();
    List<UserSimpleDTO> getAllSimpleUsers();

    // *********** GETTERS
    User getUserDetail(Long userId);
    UserDTO getUserDetailDTO(Long id);
    User getUserByEmail(String email);


    // *********** USER SEARCHING
    List<UserDTO> getUsersByFullNameOnGroupId(String fullname, Long groupId);

    // *********** CRUD
    UserDTO createUser(UserDTO userDTO);
    PasswordResetToken createPasswordResetToken(User user, String token);

    void deletePasswordResetToken(String token);

    UserSimpleDTO updateUser(Long id, UserSimpleDTO userSimpleDTO);
    void deleteUser(Long id);
    UserSimpleDTO changeAuthorOnFilesWithoutGroup(Long userId, Long newAuthorId);

    // *********** VALIDATION
    PasswordResetToken validatePasswordResetToken(String token);

    UserSimpleDTO saveUserAndReturnDTO(User user);

    void simpleSaveUser(User user);
}
