package cz.neit.dm.test_integration;

import cz.neit.security.jwt.authentication.utils.JwtTokenUtils;
import org.springframework.web.client.RestTemplate;

import java.util.Collections;

public class ControllerTestHelper {

    private static final String ADMIN_USERNAME = "petrmlady";

    private static void internalIssueToken(RestTemplate rest, JwtTokenUtils jwtTokenUtils, String username) {
        String token = "Bearer " + jwtTokenUtils.generateToken(Integer.toString(1));    //TODO potencionalni problem, tahat to ID z userDetailu
        rest.setInterceptors(
                Collections.singletonList((request, body, execution) -> {
                    request.getHeaders()
                            .add("Authorization", token);
                    return execution.execute(request, body);
                }));
    }

    /**
     * Issue token from JwtTokenUtils for admin and set the token to given rest
     * template.
     */
    public static void setAdminJwtAuthToken(RestTemplate rest, JwtTokenUtils jwtTokenUtils) {
        internalIssueToken(rest, jwtTokenUtils, ADMIN_USERNAME);
    }

    /**
     * Issue token from JwtTokenUtils for given username and set the token
     * to given rest template.
     */
    public static void setJwtAuthToken(RestTemplate rest, JwtTokenUtils jwtTokenUtils, String username) {
        internalIssueToken(rest, jwtTokenUtils, username);
    }
}
