package cz.neit.dm.test_integration.controllers;

import cz.neit.dm.dtos.modeldto.DownloadHistoryDTO;
import cz.neit.dm.test_integration.ControllerTestHelper;
import cz.neit.security.jwt.authentication.utils.JwtTokenUtils;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.boot.test.web.client.TestRestTemplate;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.test.context.ActiveProfiles;
import org.springframework.test.context.junit4.SpringRunner;

import static org.junit.Assert.assertEquals;

@RunWith(SpringRunner.class)
@SpringBootTest(webEnvironment = SpringBootTest.WebEnvironment.RANDOM_PORT)
@ActiveProfiles("test")
public class DownloadHistoryControllerTest {

    @Autowired
    TestRestTemplate rest;
    @Autowired
    JwtTokenUtils jwtTokenUtils;

    @Before
    public void setUp() {
        ControllerTestHelper.setAdminJwtAuthToken(rest.getRestTemplate(), jwtTokenUtils);
    }

    @Test
    public void testDownloadHistory() {
        ResponseEntity<DownloadHistoryDTO[]> response = rest.getForEntity("/download-history", DownloadHistoryDTO[].class);
        DownloadHistoryDTO[] body = response.getBody();

        assertEquals(HttpStatus.OK, response.getStatusCode());
        assertEquals(5, body.length);
    }
}
