package cz.neit.dm.test_integration.liquibase;

import lombok.extern.slf4j.Slf4j;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.io.File;
import java.net.URI;

/**
 * Liquibase migration integration testMigration
 */
@Slf4j
@RunWith(SpringRunner.class)
@SpringBootTest
public class LiquibaseMigrationIT {

    @Before
    public void checkConfigLocation() throws LiquibaseIntegrationConfigurationException {
        String configKey = "spring.config.additional-location";
        try {
            String configLocationString = System.getProperty(configKey);
            if (configLocationString == null || configLocationString.isEmpty()) {
                throw new LiquibaseIntegrationConfigurationException("-D" + configKey + " is empty!");
            }
            File configFile = new File(URI.create(configLocationString));
            if (!configFile.exists())
                throw new LiquibaseIntegrationConfigurationException("Expected liquibase test configuration file not found!: " + configLocationString);
            if (!configFile.canRead())
                throw new LiquibaseIntegrationConfigurationException("Unable to READ liquibase test configuration file! Permission denied!: " + configLocationString);
        } catch (IllegalArgumentException | NullPointerException e) {
            throw new LiquibaseIntegrationConfigurationException("Error while trying to test liquibase test configuration: -D" + configKey, e);
        }
    }

    @Test
    public void contextLoads() {
    }

}
